from models import db
from models.{{ model['tableName'] }} import {{ model['className'] }}

class {{ contronller['className'] }}(object):
    def __init__(self):
        super({{ contronller['className'] }}, self).__init__()

    def get(self, params):
        # handle business
        pass

    def post(self, params):
        # handle business
        result = {{ model['className'] }}.query.filter({{ model['className'] }}.areaName == args.areaName).first()
        if result and result.del_flag:
            result.del_flag = False
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
            return pretty_result(code.OK)
        elif result and result.del_flag == False:
            return pretty_result(code.EXISTS_ERROR)

        result = {{ model['className'] }}(areaCode=args.areaCode, areaName=args.areaName, level=args.level, cityCode=args.cityCode, center=args.center, parentId=args.parentId, hasChildren=args.hasChildren, create_by=jwt['id'], create_date=datetime.now(), update_by=jwt['id'], update_date=datetime.now())
        db.session.add(result)
        db.session.commit()
        return pretty_result(code.OK)

    def put(self, params):
        # handle business
        result = {{ model['className'] }}.query.get(id)
        if not result: return pretty_result(code.NO_DATA)
        if args:
            for key, value in args.items():
                if value != None: setattr(result, key, value)
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            db.session.commit()
        else:
            return pretty_result(code.PARAM_NULL)

    def delete(self, params):
        # handle business
        result = {{ model['className'] }}.query.get(id)
        if not result: return pretty_result(code.NO_DATA_FOUND)
        else:
            result.update_by = jwt['id']
            result.update_date = datetime.now()
            result.del_flag = True
            # db.session.delete(pump)
            db.session.commit()